import nz.ac.waikato.modeljunit.FsmModel;
import nz.ac.waikato.modeljunit.Action;


public class Allarme implements FsmModel {
	boolean[] sensori; //Array di booleani, TRUE = sensore acceso, FALSE = sensore spento
	
	//Inizializzo array e setto tutti i sensori a TRUE (accesi)
	public Allarme() {
		sensori = new boolean[4];
		
		sensori[0] =true;
		sensori[1] =true;
		sensori[2] =true;
		sensori[3] =true;
	}
	
	@Action
	public void toggleSensore0() {
		if (sensori[0]) sensori[0] = false;
		else sensori[0] = true;
	}
	
	public boolean toggleSensore0Guard() {
		if (!sensori[0]) return true;
		// Sono nel caso di sensore acceso e richiesta di spegnere, accetto solo se i vicini sono accesi
		if (sensori[1] && sensori[3]) return true;
		
		return false;
	}
	
	@Action
	public void toggleSensore1() {
		if (sensori[1]) sensori[1] = false;
		else sensori[1] = true;
	}
	
	public boolean toggleSensore1Guard() {
		if (!sensori[1]) return true;
		// Sono nel caso di sensore acceso e richiesta di spegnere, accetto solo se i vicini sono accesi
		if (sensori[0] && sensori[2]) return true;
		
		return false;
	}
	
	@Action
	public void toggleSensore2() {
		if (sensori[2]) sensori[2] = false;
		else sensori[2] = true;
	}
	
	public boolean toggleSensore2Guard() {
		if (!sensori[2]) return true;
		// Sono nel caso di sensore acceso e richiesta di spegnere, accetto solo se i vicini sono accesi
		if (sensori[1] && sensori[3]) return true;
		
		return false;
	}
	
	@Action
	public void toggleSensore3() {
		if (sensori[3]) sensori[3] = false;
		else sensori[3] = true;
	}
	
	public boolean toggleSensore3Guard() {
		if (!sensori[3]) return true;
		// Sono nel caso di sensore acceso e richiesta di spegnere, accetto solo se i vicini sono accesi
		if (sensori[0] && sensori[2]) return true;
		
		return false;
	}
	
	@Override
	public String getState() {
		return "["+sensori[0] + "," + sensori[1] + "," + sensori[2] + "," + sensori[3] + "]";
	}
	
	@Override
	public void reset(boolean t) {
		sensori[0] =true;
		sensori[1] =true;
		sensori[2] =true;
		sensori[3] =true;
	}
}
