import static org.junit.Assert.*;

import org.junit.Test;

//Copro tutto: Stetement, Branch e Term
public class AllarmeTestCoperturaTotale {

	@Test
	public void test1() {
		// Creo un oggetto Allarme
		Allarme a = new Allarme();
		// Controllo che a non sia nullo
		assertNotNull(a);
		// Spengo sensore 0
		assertTrue(a.setSensore(0, false));
		// Provo a spegnere sensore -1 (che per non esiste)
		assertFalse(a.setSensore(-1, false));
		// Verifico che il sensore 1 non sia acceso
		assertFalse(a.acceso(0));
		// Verifico che non vi  pericolo
		assertFalse(a.pericolo());
	}

	@Test
	public void test2() {
		// Creo un oggetto Allarme
		Allarme a = new Allarme();
		// Considero la seguente decisione
		// (sensore<0 || sensore>=N || sensori[(sensore+N-1)%N]==false ||
		// sensori[(sensore+1)%N]==false || acceso==sensori[sensore])

		// Caso in cui tutte le condizioni sono a false
		assertTrue(a.setSensore(0, false));

		// Caso in cui tutte le condizioni sono a false tranne sensore<0 che  a
		// true
		assertFalse(a.setSensore(-1, false));

		// Caso in cui tutte le condizioni sono a false tranne sensore>=4 che 
		// a true
		assertFalse(a.setSensore(4, false));

		// Caso in cui tutte le condizioni sono a false tranne
		// sensori[(sensore+N-1)%N]==false che  a true
		assertFalse(a.setSensore(1, false));

		// Caso in cui tutte le condizioni sono a false tranne
		// sensori[(sensore+1)%N]==false che  a true
		assertFalse(a.setSensore(3, false));

		// Caso in cui tutte le condizioni sono a false tranne
		// acceso==sensori[sensore] che  a true
		assertFalse(a.setSensore(0, false));
	}

}
