import static org.junit.Assert.*;

import org.junit.Test;


//Copertura decisioni/branch
//N.B la copertura delle decisioni  sempre equivalente alla copertura dei branch
//Di fatto riutilizzo lo stesso caso di test della copertura delle istruzioni, visto che gi quella aveva 
//copertura dei branch del 100%
public class AllarmeTestDecisioniBranch {

	@Test
	public void test() {
		// Creo un oggetto Allarme
		Allarme a = new Allarme();
		// Controllo che a non sia nullo
		assertNotNull(a);
		//Spengo sensore 0
		assertTrue(a.setSensore(0, false));
		//Provo a spegnere sensore -1 (che per non esiste)
		assertFalse(a.setSensore(-1, false));
		//Verifico che il sensore 1 non sia acceso
		assertFalse(a.acceso(0));
		//Verifico che non vi  pericolo
		assertFalse(a.pericolo());
		
		
		
	}

}
