import static org.junit.Assert.*;

import org.junit.Test;

//Copertura MCDC
public class AllarmeTestMCDC {

	@Test
	public void test() {
		// Creo un oggetto Allarme
		Allarme a = new Allarme();
		//Considero la seguente decisione
		//(sensore<0 || sensore>=N || sensori[(sensore+N-1)%N]==false || sensori[(sensore+1)%N]==false || acceso==sensori[sensore])
		
		//Caso in cui tutte le condizioni sono a false
		assertTrue(a.setSensore(0, false));
		
		//Caso in cui tutte le condizioni sono a false tranne sensore<0 che  a true
		assertFalse(a.setSensore(-1, false));
		
		//Caso in cui tutte le condizioni sono a false tranne sensore>=4 che  a true
		assertFalse(a.setSensore(4, false));
		
		//Caso in cui tutte le condizioni sono a false tranne sensori[(sensore+N-1)%N]==false che  a true
		assertFalse(a.setSensore(1, false));
		
		//Caso in cui tutte le condizioni sono a false tranne sensori[(sensore+1)%N]==false che  a true
		assertFalse(a.setSensore(3, false));
		
		//Caso in cui tutte le condizioni sono a false tranne acceso==sensori[sensore] che  a true
		assertFalse(a.setSensore(0, false));
		
				
	}

}
