public class Allarme {

	public boolean[] s; //array dei sensori booleano
	public int n = 4;

	public Allarme() {
		s = new boolean[n];
		int i = 0;
		while (i < n) {
			s[i] = true; //inizializzo sensori a true
			i++;
		}
	}

	public boolean setSensore(int sensore, boolean acceso) {
		//System.out.println((sensore +1 +4) % 4);
		if (sensore < 0 || sensore >= n || acceso == s[sensore]) //sensore non valido oppure non cambia lo stato del sensore 
			return false;
		//sensori adiacenti sono spenti
		else if ((acceso == false && s[(sensore - 1 + 4) % 4] == false) || (acceso == false && s[(sensore + 1 +4) % 4] == false)) {
			return false;
		}
		else{ //posso cambiare stato al sensore
			s[sensore] = acceso;
			return true;
		}

	}

	public boolean acceso(int sensore) {
		if (sensore < 0 || sensore >= n || s[sensore] == false) //sensore non valido oppure  spento
			return false;
		else
			return true; //sensore acceso
	}

	public boolean pericolo() {	
		//sensori adiacenti entrambi spenti return true (sono in pericolo)
		if( (s[0]==false && s[1]==false) || (s[1]==false && s[2]==false) || (s[2]==false && s[3]==false) || (s[3]==false && s[0]==false))
			return true;
		else
			return false;
	}

}
