import nz.ac.waikato.modeljunit.GreedyTester;
import nz.ac.waikato.modeljunit.Tester;
import nz.ac.waikato.modeljunit.VerboseListener;
import nz.ac.waikato.modeljunit.coverage.CoverageMetric;
import nz.ac.waikato.modeljunit.coverage.TransitionCoverage;
import org.junit.Test;

public class AllarmeTest {
	@Test
	public void test() {
		Tester tester = new GreedyTester(new Allarme());
		tester.buildGraph();
		CoverageMetric trCoverage = new TransitionCoverage();
		tester.addCoverageMetric(trCoverage);
		tester.addListener(new VerboseListener());
		tester.generate(100);
		tester.getModel().printMessage(trCoverage.getName() + " was "+ trCoverage.toString());
	}
}
