package test;

import static org.junit.Assert.*;

import org.junit.Test;

import Allarme.Allarme;

public class AllarmeTestIstruzioni {

	@Test
	public void test() {
		Allarme provaIstruzioni=new Allarme();
		//1.
		//spengo i sensori 0 e 2
		assertTrue(provaIstruzioni.setSensore(0, false));
		assertTrue(provaIstruzioni.setSensore(2, false));
		//2.
		//provo a spegnere gli altri sensori ma non riesco
		assertFalse(provaIstruzioni.setSensore(1, false));
		assertFalse(provaIstruzioni.setSensore(3, false));
		//verifico che effettivamente 0 e 2 siano spenti e 1 e 3 accesi
		assertFalse(provaIstruzioni.acceso(0));
		assertFalse(provaIstruzioni.acceso(2));
		assertTrue(provaIstruzioni.acceso(1));
		assertTrue(provaIstruzioni.acceso(3));
		//verifico pertanto che non siamo in una situazione di pericolo
		assertFalse(provaIstruzioni.pericolo());
		
		//provo a cambiare un sensore non esistente
		assertFalse(provaIstruzioni.setSensore(5, true));
		//provo ad accendere un sensore gi acceso
		assertFalse(provaIstruzioni.setSensore(1, true));
		//accendo un sensore spento
		assertTrue(provaIstruzioni.setSensore(0,true));
		
	}

}
