import static org.junit.Assert.*;

import org.junit.Test;

/*
 done (S0: trueS1: trueS2: trueS3: true, spegniS3, S0: trueS1: trueS2: trueS3: false)
 done (S0: trueS1: trueS2: trueS3: false, accendiS3, S0: trueS1: trueS2: trueS3: true)
 done (S0: trueS1: trueS2: trueS3: true, spegniS1, S0: trueS1: falseS2: trueS3: true)
 done (S0: trueS1: falseS2: trueS3: true, accendiS1, S0: trueS1: trueS2: trueS3: true)
 done (S0: trueS1: trueS2: trueS3: true, spegniS0, S0: falseS1: trueS2: trueS3: true)
 */

public class AllarmeTestFSM {

	@Test
	public void test() {
		Allarme a = new Allarme();

		// done (S0: trueS1: trueS2: trueS3: true, spegniS3, S0: trueS1: trueS2:
		// trueS3: false)
		assertTrue(a.setSensore(3, false)); // spegniS3

		//  done (S0: trueS1: trueS2: trueS3: false, accendiS3, S0: trueS1: trueS2: trueS3: true)
		// trueS3: false)
		assertTrue(a.setSensore(3, true)); // accendiS3

		//  done (S0: trueS1: trueS2: trueS3: true, spegniS1, S0: trueS1: falseS2: trueS3: true)
		// trueS3: false)
		assertTrue(a.setSensore(1, false)); // spegniS1

		//  done (S0: trueS1: falseS2: trueS3: true, accendiS1, S0: trueS1: trueS2: trueS3: true)
		// trueS3: false)
		assertTrue(a.setSensore(1, true)); // accendiS1

		//  done (S0: trueS1: trueS2: trueS3: true, spegniS0, S0: falseS1: trueS2: trueS3: true)
		// trueS3: false)
		assertTrue(a.setSensore(0, false)); // spegniS0
	}

}
